Subject: Re: [BUG] RTNL and flush_scheduled_work deadlocks

From: Jarek Poplawski <[email-masked]>
Date: Fri, 16 Feb 2007 09:10:51 +0100

On Thu, Feb 15, 2007 at 11:40:32PM -0800, Ben Greear wrote:
...
> Maybe there should be something like an ASSERT_NOT_RTNL() in the 
> flush_scheduled_work()
> method?  If it's performance criticial, #ifdef it out if we're not 
> debugging locks?

Yes! I thought about the same (at first). But in my
opinion it was not enough, so I thought about doing
this in flush_workqueue. But in my next opinion it
was not enough too. Now I think something like this
should be done in rtnl_lock (under some debugging #if
of course). 

Cheers,
Jarek P.